#include "DataStructure.h"
#include <iostream>
#include <vector>
#include <iomanip>
#include <array>
std::ostream& operator << (std::ostream& out, const std::vector <int>& elem) {
	for (const auto& i : elem) {
		out << i << " ";
	}
	out << std::endl;
	return out;
}

std::ostream& operator << (std::ostream& out, const std::set<int>& elem) {
	for (const auto& i : elem) {
		out << i << " ";
	}
	out << std::endl;
	return out;
}
std::ostream& operator<<(std::ostream& out_stream, const Node& node_) {
	for (const auto& elem : node_.Coordinate) {
		out_stream << std::setw(15)<<elem;
	}
	return out_stream;
}

std::ostream& operator << (std::ostream& out, const std::vector<Node>& elem) {
	for_each(elem.begin(), elem.end(), [&](const auto& i) {
		out << "   ID node: " << i.ID_Node << std::endl;
		out << "   Coordinateates: ";
		for_each(i.Coordinate.begin(), i.Coordinate.end(), [&](const auto& j) {
			out << j << " ";
			});
		out << std::endl << "   Flag: " << i.flag << std::endl << std::endl;
		});
	return out;
}

std::ostream& operator << (std::ostream& out, const std::set <FiniteElement>& elem) {
	for_each(elem.begin(), elem.end(), [&](const auto& i) {
		out << "   ID_FiniteElement: " << i.ID_FiniteElement << std::endl;
		out << "   ID_Material: " << i.ID_Material << std::endl;
		out << "   ID_Nodes: ";
		for_each(i.ID_Nodes.begin(), i.ID_Nodes.end(), [&](const auto& j) {
			out << j << " ";
			});
		out << std::endl << std::endl;
		});
	return out;
}
std::ostream& operator << (std::ostream& out, const std::vector <FiniteElement>& elem) {
	for_each(elem.begin(), elem.end(), [&](const auto& i) {
		out << "   ID_FiniteElement: " << i.ID_FiniteElement << std::endl;
		out << "   ID_Material: " << i.ID_Material << std::endl;
		out << "   ID_Nodes: ";
		for_each(i.ID_Nodes.begin(), i.ID_Nodes.end(), [&](const auto& j) {
			out << j << " ";
			});
		out << std::endl << std::endl;
		});
	return out;
}

