#pragma once
#include "DataStructure.h"

class MeshLoader {
protected:
	std::vector<Node> node;
	std::vector<FiniteElement> finite_el;
	std::vector<FiniteElement> boundary_el;

public:
	virtual void loadMesh(const std::string&) = 0;
	virtual ~MeshLoader() = default;
	std::vector<Node>& GetNode();
	std::vector<FiniteElement>& GetFiniteElement();
	std::vector<FiniteElement>& GetBoundaryElement();
	std::vector<int> ElementByThreeNodes(int, int, int);
	std::vector<int> ElementByTwoNodes(int id1, int id2);
	std::vector<int> FiniteElementsByAreaID(int id);
	std::vector<int> BoundaryElementsByBoundaryID(int id);
	std::set<int> BoundaryNodesByBoundaryID(int);
	void insert_middle();
	std::vector<std::set<int>> Neighbor_Nodes();
	void print_DataTypes();
};


std::ostream& operator << (std::ostream& out, const std::vector<std::set<int>>& elem);
std::ostream& operator << (std::ostream& out, const std::set <int>& elem);
std::ostream& operator << (std::ostream& out, const std::vector <int>& elem);



